---
name: Bug report (run time, unexpected exception, something is broken on my computer)
about: Create a report to help us fix a problem in AP.exe
---
<!--
Please follow the instructions in the link below before filing a bug report.

https://github.com/QutEcoacoustics/audio-analysis/blob/master/docs/basics/bug_report.md

-->

## Describe the bug

A clear and concise description of what the bug is.

## Expected behavior 

A clear and concise description of what you expected to happen.

## Diagnostics

<!-- Try to answer as many questions as possible -->

### Instructions

✅ I have followed the [instructions for reporting a bug](https://github.com/QutEcoacoustics/audio-analysis/blob/master/docs/basics/bug_report.md)

### I have attached a log:

<!-- Information about log files can be found here: -->
<!-- https://github.com/QutEcoacoustics/audio-analysis/blob/master/docs/basics/logs.md#log-files -->
<!-- 👇 Drag and drop the log into the empty line below -->

<!-- 👆 -->

### The **operating system** I'm using is:  

<!-- e.g. Windows 10 Version 1809 -->  


### The version of **AnalysisPrograms.exe** I'm using is:

<!-- e.g. 18.05.3.6 -->


### The data used can be found:

<!-- Describe or provide the data relevant to this bug below -->
<!-- If the data is sensitive or too large to easily be shared -->
<!-- then describe the shape of it (size, duration, count, format, etc..) -->
<!-- and we'll try to use simulated data. If we need more information -->
<!-- then we'll contact you privately. -->



<!-- 👇 Optionally, drag and drop **SMALL** files into the empty line below-->

<!-- 👆 -->

### The command I used:

<!-- 👇 Copy and paste the command you used in the empty line below -->
```

```
<!-- 👆 -->

### The config file I used:

<!-- 👇 Drag and drop the log into the empty line below -->

<!-- 👆 -->


## Screenshots

<!-- If applicable, add screenshots to help explain your problem. Drag and drop into the space below. -->


## Additional Details

<!-- Add any other context about the problem here. -->
