*QUT Ecoacoustics Analysis Programs* is a software package that can perform a  suite of analyses on audio recordings of
the environment. Although the analyses are intended for long-duration recordings (1 – 24 hours), in fact they
can be performed on any audio file in a format supported by the software. Analysis Programs can:

- calculate of summary and spectral acoustic indices at variable resolutions
- produce long-duration, false-colour, multi-index spectrograms
- calculate critical statistics of annotations downloaded from an Acoustic Workbench
- run various acoustic event recognizers

All the analyses are performed by a single executable file, _AnalysisPrograms.exe_.

The project is open source and licensed under the Apache License 2.0.

## Quick links

- Come chat on [Gitter](https://gitter.im/QutEcoacoustics/audio-analysis) with us 🙂
   [![Gitter](https://badges.gitter.im/QutEcoacoustics/audio-analysis.svg)](https://gitter.im/QutEcoacoustics/audio-analysis?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge)
- See these docs for instructions on
  - [Downloading](xref:basics-installing) AnalysisPrograms.exe
  - Running the program
  - Understanding concepts
- See the **[Issues list](https://github.com/QutEcoacoustics/audio-analysis/issues)** for
  - reporting bugs
  - requesting new features
- See the **[Contributing guidelines](../CONTRIBUTING.md)** if you want to
  - Compile the code yourself
  - Make a contribution
- [Let us know](https://github.com/QutEcoacoustics/audio-analysis/wiki/Projects-and-people-using-AP.exe) if you're using AP.exe

## Citation

[![DOI](https://zenodo.org/badge/18597929.svg)](https://zenodo.org/badge/latestdoi/18597929)

This citation should be used in all publications that use data, concepts, or results generated by AnalysisPrograms.exe or from this code base:

> Michael Towsey, Anthony Truskinger, Mark Cottman-Fields, & Paul Roe. (2018, March 5). Ecoacoustics Audio Analysis Software v18.03.0.41 (Version v18.03.0.41). Zenodo. <http://doi.org/10.5281/zenodo.1188744>

Additionally, depending on the analysis that was run, extra work may be required to be cited. Any such additional
citations will printed in the console and in the log file.
